#include <PalmOS.h>
#include "T-Suite.h"
#include "PalmChars.h"

#define DALFormID 9900
#define DALListID 9902

#define vchrJogUp				0x1700
#define vchrJogDown				0x1701
#define vchrJogRelease			0x1706
#define vchrJogBack				0x1707 		/* added @ 2001 */

Err ADalEventDequedHandle (SysNotifyParamType *notifyParamsP)
{

	EventType *event = (EventType*)notifyParamsP->notifyDetailsP;

	if (Swap16 (event->eType) == keyDownEvent)
	{
		if (FrmGetActiveFormID () == DALFormID)
		{
			UInt16 ObjIndex = FrmGetObjectIndex (FrmGetActiveForm (), DALListID);
			if (ObjIndex != frmInvalidObjectId)
			{
				ListType *listP = (ListType*)FrmGetObjectPtr (FrmGetActiveForm (), ObjIndex);
				Int16 numOfItems = LstGetNumberOfItems (listP);
				Int16 selection = LstGetSelection (listP);
				switch (Swap16 (event->data.keyDown.chr))
				{
				case vchrPageUp:	//JogUp
				case chrUpArrow:
					if (selection == 0)
						LstSetSelection (listP, numOfItems - 1);
					else
						LstSetSelection (listP, selection -1);
					event->eType = (eventsEnum)0;
					goto handled;
				case vchrPageDown:	//JogDown
				case chrDownArrow:
					if (selection == numOfItems - 1)
						LstSetSelection (listP, 0);
					else
						LstSetSelection (listP, selection + 1);
					event->eType = (eventsEnum)0;
					goto handled;
				case vchrHard3:		//JogSelect
				case vchrHard4:
				case chrLineFeed:
//				case 5waySel:
					event->data.keyDown.chr = Swap16 (chrLineFeed);
					goto handled;
				case vchrHard1:		//JogBack
				case vchrHard2:
				case chrBackspace:
				case chrLeftArrow:
				case chrRightArrow:
//				case 5wayLeft:
//				case 5wayRight:
					event->eType = (eventsEnum)Swap16 (penDownEvent);
					event->penDown = true;
					event->tapCount = 1;
					event->screenX = Swap16 (-1);
					event->screenY = Swap16 (-1);
					goto handled;
				}

				// 5-way navigation Handle---------------------------------
				EventType newEvent;
				MemSet (&newEvent, sizeof (newEvent), 0);
				newEvent.eType =  (eventsEnum)Swap16 (event->eType);
				newEvent.data.keyDown.chr = Swap16 (event->data.keyDown.chr);
				newEvent.data.keyDown.keyCode = Swap16 (event->data.keyDown.keyCode);
				newEvent.data.keyDown.modifiers = Swap16 (event->data.keyDown.modifiers);

				if (NavSelectPressed(&newEvent))
					event->data.keyDown.chr = Swap16 (chrLineFeed);
				if ((NavKeyPressed(&newEvent, Left)) || (NavKeyPressed(&newEvent, Right)))
				{
					event->eType = (eventsEnum)Swap16 (penDownEvent);
					event->penDown = true;
					event->tapCount = 1;
					event->screenX = Swap16 (-1);
					event->screenY = Swap16 (-1);
				}

handled:{}
			}
		}
	}
	
	notifyParamsP->handled = true;

	return errNone;
}